;	Double Jump
;	HuFlungDu
;	Basically it's what the name says. It will allow mario to double jump. The second jump height is configurable
;	if you look farther down in the patch. It requires some free RAM, and the one I gave it is the most
;	overused free RAM ever, so I suggest you repoint it.
;	No credit necessary


macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom                   			;\ ROM is LoRom
header                  			;/ and has a header.

!freeram = $0660					; Your pobably gonna want to point this elsewhere
!secondjumpheight = $C0				; This is the speed stored to mario's Y speed (HEX).
									; The lower it is, the higher you go.
!freespace = $218015				; If you don't know what this means... go find a tutorial
									
org $A21B               			;\ Hijack routine that runs every frame (you can change this 
									;/ if you know what you are doing, otherwise, leave this alone)
JSL Djump 							;Then jump to the code

org !freespace
%RATS_start(0)						; A RAT tag to keep LM from overwiting our code
Djump:
LDA $77								; 
AND #$04	 						; Check if mario is on ground
BNE reset
LDA $75								; Check if mario is in water
BEQ notwater
STZ !freeram
BRA reset
notwater:
LDA !freeram						;\ Check if you've already jumped (doesn't allow you to jump twice in the air)
BNE reset							;/
LDA $16         					;\ check if either B or A is pressed
AND #$80        					; |
BEQ return        					;/ if neither, return
LDA $18         	  				;\ check if it's B that's pressed
AND #$80        				    ; |if A, not B,
BNE return      					;/ return
LDA $7D								;Don't jump if mario is going down
BPL return							;(just comment out these lines if you want him to be able to)
LDA #!secondjumpheight				;\ Make mario jump
STA $7D								;/
LDA #$01							;\Make sound effect
STA $1DFA							;/
INC !freeram						; Increase the freeram, telling the game that you 
									;just jumped and can't do it again
reset:
LDA $77								;  |
AND #$04	 						; Check if mario is on ground
BEQ return
STZ !freeram						; Reset the freeram if mario is touching the ground
return:
LDA $16								;\ Restore Hijacked code
AND #$10							;/ (Don't touch unless you know what you are doing)
RTL
%RATS_end(0)